//+------------------------------------------------------------------+
//|                                           Volatility quality.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Cyan
#property indicator_color6  Yellow
#property indicator_color7  Orchid
#property indicator_color8  Goldenrod
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style7  STYLE_DOT
#property indicator_style8  STYLE_DOT

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Length          = 1;
extern int    Method          = MODE_LWMA;
extern double Filter          = 1.5;
extern int    MA1Period       = 9;
extern int    MA1Mode         = MODE_SMA;
extern int    MA1Price        = PRICE_CLOSE;
extern int    MA2Period       = 200;
extern int    MA2Mode         = MODE_SMA;
extern int    MA2Price        = PRICE_CLOSE;
extern bool   Interpolate     = true;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";
extern bool   ShowShortTermMa = true;
extern bool   ShowLongTermMa  = true;

//
//
//
//
//

double UpBuffer[];
double DnBuffer[];
double upBody[];
double dnBody[];
double UpArrow[];
double DnArrow[];
double sumVqi[];
double sumVqi1[];
double sumVqi2[];
double Vqi[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);
      SetIndexBuffer(0, UpBuffer); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1, DnBuffer); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2, upBody);   SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3, dnBody);   SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4, UpArrow);  SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,233);
      SetIndexBuffer(5, DnArrow);  SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,234);
      SetIndexBuffer(6, sumVqi1);
      SetIndexBuffer(7, sumVqi2);
      SetIndexBuffer(8, sumVqi);
      SetIndexBuffer(9, Vqi); 
      SetIndexBuffer(10,trend);
      
      if (ShowShortTermMa)
      {
         SetIndexStyle(6,DRAW_LINE);  
      }
      else
      {
         SetIndexStyle(6,DRAW_NONE);
      }      
      
      //
      //
      //
      //
      //
      
      if (ShowLongTermMa)
      {
         SetIndexStyle(7,DRAW_LINE);  
      }
      else
      {
         SetIndexStyle(7,DRAW_NONE);
      }      

      //
      //
      //
      //
      //
      
      Filter            = MathMax(Filter,0);
      Length            = MathMax(Length,1);       
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+" VQ candles ("+Length+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars < 0)  return(-1);
   if(counted_bars > 0)  counted_bars--;
      limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { UpBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     double pointModifier = MathPow(10,Digits%2);
     for (i=limit; i>= 0; i--)
     {
      if (i==(Bars-1))
       {
         Vqi[i]    = 0;
         sumVqi[i] = 0;
         continue;
       }
      
      //
      //
      //
      //
      //
      
         double cHigh  = iMA(NULL,0,Length,0,Method,PRICE_HIGH, i);
         double cLow   = iMA(NULL,0,Length,0,Method,PRICE_LOW,  i);
         double cOpen  = iMA(NULL,0,Length,0,Method,PRICE_OPEN, i);
         double cClose = iMA(NULL,0,Length,0,Method,PRICE_CLOSE,i);
         double pClose = iMA(NULL,0,Length,0,Method,PRICE_CLOSE,i+1);
         if (MA1Period > 1) sumVqi1[i] = iMA(NULL,0,MA1Period,0,MA1Mode,MA1Price,i);
         if (MA2Period > 1) sumVqi2[i] = iMA(NULL,0,MA2Period,0,MA2Mode,MA2Price,i);
         double trueRange = MathMax(cHigh,pClose)-MathMin(cLow,pClose);
         double     range = cHigh-cLow;
      
            if (range != 0 && trueRange != 0)
               double vqi = ((cClose-pClose)/trueRange + (cClose-cOpen)/range)*0.5;
            else      vqi = Vqi[i+1];

            //
            //
            //
            //
            //
         
            Vqi[i]   = MathAbs(vqi)*(cClose-pClose+cClose-cOpen)*0.5;
            sumVqi[i]= sumVqi[i+1]+Vqi[i];
            if (Filter > 0.0) if (MathAbs(sumVqi[i]-sumVqi[i+1]) < Filter*pointModifier*Point) sumVqi[i] = sumVqi[i+1];
            
            //
            //
            //
            //
            //
            
            trend[i] = trend[i+1];
            if (sumVqi[i] > sumVqi[i+1]) trend[i] =  1;
            if (sumVqi[i] < sumVqi[i+1]) trend[i] = -1;
            if (trend[i]== 1) { DnBuffer[i] = Low[i];  UpBuffer[i] = High[i]; upBody[i] = MathMax(Open[i],Close[i]); dnBody[i] = MathMin(Open[i],Close[i]);}
            if (trend[i]==-1) { DnBuffer[i] = High[i]; UpBuffer[i] = Low[i];  upBody[i] = MathMin(Open[i],Close[i]); dnBody[i] = MathMax(Open[i],Close[i]);}
            
            //
            //
            //
            //
            //
            
            UpArrow[i] = EMPTY_VALUE; 
            DnArrow[i] = EMPTY_VALUE;
            if (trend[i] !=trend[i+1])
            if (trend[i] == 1)
                 UpArrow[i] = Low[i] - iATR(NULL,0,20,i)/2;
            else DnArrow[i] = High[i]+ iATR(NULL,0,20,i)/2;
      }
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int shift = 1;
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+shift]); 
          sumVqi1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,6,y);
          sumVqi2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,7,y);
          trend[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,10,y);
       if (x!=y)
       {
          UpBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
          DnBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
          upBody[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
          dnBody[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
          UpArrow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,4,y);
          DnArrow[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Method,Filter,MA1Period,MA1Mode,MA1Price,MA2Period,MA2Mode,MA2Price,false,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,5,y);
       }
       else
       {
          UpBuffer[i] = EMPTY_VALUE;
          DnBuffer[i] = EMPTY_VALUE;  
          upBody[i]   = EMPTY_VALUE;
          dnBody[i]   = EMPTY_VALUE;  
          UpArrow[i]  = EMPTY_VALUE;
          DnArrow[i]  = EMPTY_VALUE;  
       }                      
      
          //
          //
          //
          //
          //
       
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int k = 1; k < n; k++)
             { 
                sumVqi1[i+k] = sumVqi1[i] + (sumVqi1[i+n] - sumVqi1[i]) * k/n;
                sumVqi2[i+k] = sumVqi2[i] + (sumVqi2[i+n] - sumVqi2[i]) * k/n;
             }  
    }
return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(Period())+" VQ ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," VQ "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

